package org.redhat.gss.remotedrools;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.kie.api.runtime.KieSession;
import org.kie.api.task.TaskService;
import org.kie.remote.client.api.RemoteRestRuntimeEngineFactory;
import org.kie.remote.client.api.RemoteRuntimeEngineFactory;
import org.kie.remote.client.jaxb.ClientJaxbSerializationProvider;
import org.kie.remote.client.jaxb.JaxbCommandsRequest;
import org.kie.remote.jaxb.gen.CompleteWorkItemCommand;
import org.kie.remote.jaxb.gen.JaxbStringObjectPairArray;
import org.kie.remote.jaxb.gen.util.JaxbStringObjectPair;
import org.kie.services.client.api.command.RemoteRuntimeEngine;
//import org.kie.services.client.api.RemoteRestRuntimeFactory; // 603
//import org.kie.services.client.api.command.RemoteRuntimeEngine; //603
import org.kie.services.client.serialization.JaxbSerializationProvider;
// 610
// 610

/**
 * This is a very simple Rest Client to test against a running instance of the KIE Workbench. You can parameterize - the
 * Deployment Unit Id - the Application URL - the user/pass to execute operations
 */
public class Main {
	


	public static void main(String[] args) throws Exception {
		
		// create client provider
//		JaxbSerializationProvider PROVIDER = ClientJaxbSerializationProvider.newInstance();
//		PROVIDER.setPrettyPrint(true);
//		PROVIDER.addJaxbClassesAndReinitialize(java.util.HashSet.class);
//
//		// create set
//		Set<String> set1 = new HashSet<>();
//		set1.add("asd");
//
//		// create string object pair
//		JaxbStringObjectPair p5 = new JaxbStringObjectPair();
//		p5.setKey("key5");
//		p5.setValue(set1);	
//		JaxbStringObjectPairArray params = new JaxbStringObjectPairArray();
//		params.getItems().add(p5);
//
//		// complete work item
//		CompleteWorkItemCommand cmd = new CompleteWorkItemCommand();
//		cmd.setId(1);
//		cmd.setResult(params);
//
//		JaxbCommandsRequest req = new JaxbCommandsRequest("g:a:v:1", cmd);
//		req.setProcessInstanceId(1L);
//		req.setVersion("1");

		// serialize
//		String tmp = PROVIDER.serialize(req);
//		System.out.println(tmp);
//		
		
	 
	 
	
		/*
		 * Set the parameters according your installation
		 */

		String APP_URL = "http://localhost:8080/business-central/";
//
		URL url = new URL(APP_URL);
		String USER = "anton";
		String PASSWORD = "password1!";
		String deploymentId = "org.redhat.gss:HashMapProject:1.0";
//
		// 6.1.0
		RemoteRestRuntimeEngineFactory restSessionFactory = RemoteRuntimeEngineFactory.newRestBuilder().addDeploymentId(deploymentId).addUrl(url)
				.addUserName(USER).addPassword(PASSWORD)

				.buildFactory();
		RemoteRuntimeEngine engine = restSessionFactory.newRuntimeEngine();

		// 6.0.3

		// RemoteRestRuntimeFactory restSessionFactory = new RemoteRestRuntimeFactory(deploymentId, url, USER,
		// PASSWORD);
		// RemoteRuntimeEngine engine = restSessionFactory.newRuntimeEngine();
		KieSession kSession = engine.getKieSession();
		TaskService taskService = engine.getTaskService();
		
		List<Long> taskList = taskService.getTasksByProcessInstanceId(13);
		System.out.println("list size shuold be 1:"+taskList.size());
		
		
		// create task results - type Map
		Map<String,String> sampleMap = new HashMap<String,String>();
		sampleMap.put("SampleKey", "SampleValue");
		// create task results - type Set
		Set<String> sampleSet = new HashSet<String>();
		sampleSet.add("entry");
		
		
		Map<String,Object> taskResults = new HashMap<String,Object>();
		taskResults.put("sampleOutput", sampleMap);
		taskResults.put("sampleOutput2", sampleSet);
		
		//send them remotely
		taskService.start(taskList.get(0), "anton");
		taskService.complete(taskList.get(0), "anton", taskResults);
		
		taskList = taskService.getTasksByProcessInstanceId(13);
		System.out.println("list size shuold be 0 / null:"+taskList);
		
		
	//	JaxbSerializationProvider PROVIDER = ClientJaxbSerializationProvider.newInstance();
	//	PROVIDER.addJaxbClasses(arg0);


// output variable - sampleOutput - type Map

		System.exit(0);

	}

	private static void sendGet() throws Exception {

		String url = "http://localhost:8080/business-central/rest/task/22/";

		URL obj = new URL(url);
		HttpURLConnection con = (HttpURLConnection) obj.openConnection();

		// optional default is GET
		con.setRequestMethod("GET");

		// add request header
		con.setRequestProperty("User-Agent", "Mozilla/5.0");

		String userpass = "anton" + ":" + "password1!";
		String basicAuth = "Basic " + javax.xml.bind.DatatypeConverter.printBase64Binary(userpass.getBytes());

		con.setRequestProperty("Authorization", basicAuth);

		int responseCode = con.getResponseCode();
		System.out.println("\nSending 'GET' request to URL : " + url);
		System.out.println("Response Code : " + responseCode);

		BufferedReader in = new BufferedReader(new InputStreamReader(con.getInputStream()));
		String inputLine;
		StringBuffer response = new StringBuffer();

		while ((inputLine = in.readLine()) != null) {
			response.append(inputLine);
		}
		in.close();

		// print result
		System.out.println(response.toString());

	}

}
